from Products.ZSQLMethods.SQL import SQL
from Globals import Persistent
import Acquisition
from Acquisition import Implicit
from cPickle import dumps, loads

from Shared.DC.ZRDB.TM import TM, Surrogate
from Session import BaseSessionInstance

import sys

class sqlSessionInstance(BaseSessionInstance, TM):

    """This is a session instance that stores it's self in a SQL
    DB.
    """
    
    def __setattr__(self, attr, value):
        
        self.__dict__[attr] = value
        if not self._registered:
            self._register()
        
        
        
    def tpc_finish(self, *ignored):
        
        if self._registered:
            #import pdb; pdb.set_trace()
            parent = self._parent
            del self.__dict__['_parent']
            self.__dict__['_registered']=0
            sqlm = parent.sqlUpdateSessionInstance
            sqlm(session_id = self.id, obj = dumps(self)) 
            

class sqlSessionStorage(Persistent, Implicit):
        
    def __init__(self, conn_id):
        self.conn_id = conn_id

        _sqlGetSessionInstance = """\
        SELECT * FROM sessionstorage
        WHERE
        session_id = <dtml-sqlvar session_id type=string>
        """
        
        self.sqlGetSessionInstance = SQL('sqlGetSessionInstance', '', self.conn_id,
                                    'session_id',
                                    _sqlGetSessionInstance)
        
        
        _sqlAddSessionInstance = """\
        INSERT INTO sessionstorage
        VALUES(
        <dtml-sqlvar session_id type=string>,
        <dtml-sqlvar obj type=string>
        )
        """
        
        self.sqlAddSessionInstance = SQL('sqlAddSessionInstance', '', self.conn_id,
                                    'session_id\nobj',
                                    _sqlAddSessionInstance)
        
        _sqlUpdateSessionInstance = """\
        UPDATE sessionstorage
        SET
        obj = <dtml-sqlvar obj type=string>
        WHERE
        session_id = <dtml-sqlvar session_id type=string>
        """
        
        self.sqlUpdateSessionInstance = SQL('sqlUpdateSessionInstance', '', self.conn_id,
                                       'session_id\nobj',
                                       _sqlUpdateSessionInstance)
        
        self.sqlListSessionKeys = SQL('sqlListSessionKeys', '', self.conn_id,
                                 '',
                                 "SELECT session_id "
                                 "FROM sessionstorage")
        
        self.sqlListObjects = SQL('sqlListObjects', '', self.conn_id,
                             '',
                             "SELECT * "
                             "FROM sessionstorage")
        
        self.sqlClearSessions = SQL('sqlClearSessions', '', self.conn_id,
                               '',
                               "DELETE FROM sessionstorage")
        
        
    def __delitem__(self, key):
        pass

    def __getitem__(self, key):
        sqlm = self.sqlGetSessionInstance
        rr = sqlm(session_id = key)
        
        try:
            
            obj = loads(rr[0].obj)
            obj.__dict__['_parent'] = self
            return obj
        except IndexError:
            # Re-raise the error as a KeyError
            raise KeyError, key

    def __len__(self):
        pass

    def __setitem__(self, key, v):
        # Adds the item to the cache and the stores it in the
        # db for later retrieval

        v.__dict__['_registered']=0 #
        
        sqlm = self.sqlAddSessionInstance
        sqlm(session_id = key, obj = dumps(v))
        
    

    def clear(self):
        sqlm = self.sqlClearSessions
        return sqlm()

    def copy(self):
        raise RuntTimeError, "Copying this item is stupid."

    def get(self, key, default):
        pass

    def has_key(self,key):
        # This is an expensive function because generally has key is
        # called before doing a get. It would be best to run through the
        # Session code and change all calls to has_key to try..except
        # blocks.
        try:
            obj = self.__getitem__(key)
            return 1
        except KeyError:
            return 0
        

    def items(self):
        #return map(lambda k, d=self: (k,d[k]), self.keys())
        pass
    
    def keys(self):
        
        sqlm = self.sqlListSessionKeys
        return sqlm()

    def update(self, b):
        pass

    def values(self):
        # return map(lambda k, d=self: d[k], self.keys())
        
        sqlm = self.sqlListObjects
        return map(lambda r: loads(r.obj), sqlm())
        

